Imports System.ComponentModel.DataAnnotations
Imports UoWTestApp.Interfaces

Partial Public Class Currency
    Inherits model_base
    Implements IDelete


    Dim vId As Integer
    Dim vCurrSymbol As String
    Dim vCurrName As String
    Dim vCurrConversionRate As Decimal = 1
    Dim vCurrConversionRateDate As Date = Date.Now

#Region "Mapped"
    Public Property Id As Integer
        Get
            Return vId
        End Get
        Set(value As Integer)
            If vId <> value Then
                vId = value
                'NotifyPropertyChanged("Id")
            End If
        End Set
    End Property

    <Display(Name:="Whrungssymbol", Description:="Symbol der Whrung", Order:=1)>
    <Required(AllowEmptyStrings:=False, ErrorMessage:="Whrungsymbol muss angegeben sein")>
    <StringLength(10)>
    Public Property CurrSymbol As String
        Get
            Return vCurrSymbol
        End Get
        Set(value As String)
            If vCurrSymbol <> value Then
                vCurrSymbol = value
                'NotifyPropertyChanged("CurrSymbol")
            End If
        End Set
    End Property

    <Display(Name:="Whrungsbezeichnung", Description:="Whrungsbezeichnung in Langform", Order:=2)>
    <Required(ErrorMessage:="Whrungsbezeichnung muss angegeben sein")>
    Public Property CurrName As String
        Get
            Return vCurrName
        End Get
        Set(value As String)
            If vCurrName <> value Then
                vCurrName = value
                Debug.Print("vcurrname: " & value)
                'NotifyPropertyChanged("CurrName")
            End If
        End Set
    End Property

    <Display(Name:="Umrechnungsrate", Description:="Umrechnungsrate im Vergleich zur Basiswhrung", Order:=3)>
    <Required>
    <Range(Decimal.MinValue, Decimal.MaxValue, ErrorMessage:="Umrechnungsrate muss angegeben sein")>
    Public Property CurrConversionRate As Decimal
        Get
            Return vCurrConversionRate
        End Get
        Set(value As Decimal)
            If vCurrConversionRate <> value Then
                vCurrConversionRate = value
                'NotifyPropertyChanged("CurrConversionRate")
            End If
        End Set
    End Property

    <Display(Name:="Umrechnungsratendatum", Description:="Datum der letzten Aktualisierung der Umrechnungsrate", Order:=4)>
    <Required(AllowEmptyStrings:=False, ErrorMessage:="Umrechnungsratendatum muss angegben sein")>
    Public Property CurrConversionRateDate As Date
        Get
            Return vCurrConversionRateDate
        End Get
        Set(value As Date)
            If vCurrConversionRateDate <> value Then
                vCurrConversionRateDate = value
                'NotifyPropertyChanged("CurrConversionRateDate")
            End If
        End Set
    End Property


    Dim vDeleted As Boolean
    Dim vDeletedTimeStamp As Date?

    Public Property Deleted As Boolean Implements IDelete.Deleted
        Get
            Return vDeleted
        End Get
        Set(value As Boolean)
            If vDeleted <> value Then
                vDeleted = value
                'NotifyPropertyChanged("Deleted")
            End If
        End Set
    End Property

    Public Property DeletedTimeStamp As Date? Implements IDelete.DeletedTimeStamp
        Get
            Return vDeletedTimeStamp
        End Get
        Set(value As Date?)
            vDeletedTimeStamp = value
            'NotifyPropertyChanged("DeletedTimeStamp")
        End Set
    End Property
#End Region

#Region "Navigation Properties"

#End Region

End Class
