﻿Imports UoWTestApp.Core
Imports UoWTestApp.Core.Repositories
Imports UoWTestApp.Persistence.Repositories

Namespace Persistence
    Public Class UnitOfWork
        Implements IUnitOfWork

        Private ReadOnly Property _context As UoWTestAppModelCore

        Sub New(ByVal context As UoWTestAppModelCore)
            _context = context
            Currencies = New CurrenciesRepository(_context)
        End Sub

#Region "Accounting"
        Public Property Currencies As ICurrenciesRepository Implements IUnitOfWork.Currency
#End Region

        Public Function Complete() As Integer Implements IUnitOfWork.Complete
            Return _context.SaveChanges
        End Function

#Region "IDisposable Support"
        Public Sub Dispose() Implements IDisposable.Dispose
            _context.Dispose()
        End Sub
#End Region
    End Class
End Namespace
