﻿'
'  In App.xaml:
'  <Application.Resources>
'      <vm:ViewModelLocator xmlns:vm="clr-namespace:HHHB3"
'                           x:Key="Locator" />
'  </Application.Resources>
'  
'  In the View:
'  DataContext="{Binding Source={StaticResource Locator}, Path=ViewModelName}"
'
'  You can also use Blend to do all this with the tool's support.
'  See http://www.galasoft.ch/mvvm
'


Imports GalaSoft.MvvmLight
Imports GalaSoft.MvvmLight.Ioc
Imports GalaSoft.MvvmLight.Views
Imports UoWTestApp.ViewModel

Namespace UoWTestApp.ViewModel
    ''' <summary>
    ''' This class contains static references to all the view models in the
    ''' application and provides an entry point for the bindings.
    ''' </summary>
    Public Class ViewModelLocator
        ''' <summary>
        ''' Initializes a new instance of the ViewModelLocator class.
        ''' </summary>
        Public Sub New()
            SimpleIoc.Default.Register(Of MainViewModel)()
            SimpleIoc.Default.Register(Of VMCurrencies)() 'Currencies

        End Sub

        Public ReadOnly Property MainViewModel() As MainViewModel
            Get
                Dim instance = SimpleIoc.Default.GetInstance(Of MainViewModel)()
                Return instance
            End Get
        End Property


#Region "Accouting"

        Public ReadOnly Property Currencies() As VMCurrencies
            Get
                Dim instance = SimpleIoc.Default.GetInstance(Of VMCurrencies)()
                Return instance
            End Get
        End Property

#End Region



        Public Shared Sub Cleanup()
            ' TODO Clear the ViewModels
            SimpleIoc.Default.Reset()
        End Sub
    End Class
End Namespace